/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// CORBA Reference Application
// Copyright (c) 1997 by Borland International, All Rights Reserved
//
// Contains Callback Thread Class
//--------------------------------------------------------------------------------------------------

package borland.reference.creditapproval.client;

/**
*  A thread that instantiates a callback object, registers it with
*  the ORB and processes CORBA request.
*/
public class CallbackThread extends Thread {

  protected ClientCallbackImpl callback = null;

  /**
  *  Return a reference to the callback object
  */
  public ClientCallbackImpl getCallback() {
    return callback;
  }

  /**
  *  Construct the CallbackThread Object
  */
  public CallbackThread() {

    // Create the Client Callback Class
    callback = new ClientCallbackImpl();

  }

  /**
  *  Create the callback object and register it with the ORB
  */
  public void run() {
    try {
      // Initialize the ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();

      // Initialize the BOA
      org.omg.CORBA.BOA boa = orb.BOA_init();

      // Export the Callback Class
      boa.obj_is_ready( callback );

      // Service Requests.
      boa.impl_is_ready();
    }
    catch( org.omg.CORBA.SystemException e) {
      System.err.println(e);
    }

  }
}
