/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// CORBA Reference Application
// Copyright (c) 1997 by Borland International, All Rights Reserved
//
// Panel containing Credit Card Application
//--------------------------------------------------------------------------------------------------

package borland.reference.creditapproval.client;

import borland.reference.creditapproval.CORBAInterface.*;
import java.util.*;

/**
* ClientCallbackImpl implements the IDL-defined ClientCallback
* interface.
*
* This class allows the Server to provide status information to the
* client.
*/
public class ClientCallbackImpl extends _sk_ClientCallback {

  protected CallbackObservable observable = new CallbackObservable();

  /**
  *  Construct a persistently named object.
  */
  public ClientCallbackImpl(java.lang.String name) {
    super(name);
  }

  /**
  *  Construct a transient object.
  */
  public ClientCallbackImpl() {
    super();
  }

  /**
  *   Provide access to the embedded Observerable Object
  */
  public void addObserver( Observer newObserver ) {
    observable.addObserver( newObserver );
  }
  /**
  *   Provide access to the embedded Observerable Object
  */
  public void deleteObserver( Observer newObserver ) {
    observable.deleteObserver( newObserver );
  }

  /**
  *   Update the status string using the embedded Observable
  */
  public void updateStatusText( java.lang.String newStatus ) {
     observable.setStatusText(newStatus);
  }
}

/**
*   Since setChanged is protected, this class had to be created
*  versus embedding an object of type Observable.
*/
class CallbackObservable extends Observable {

  public CallbackObservable() {
    super();
  }
  /**
  *  Notify all Observers of the new status text.
  */
  public void setStatusText(String newStatus){
    setChanged();
    notifyObservers(newStatus);
  }

}
