/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
//--------------------------------------------------------------------------------------------------
// CORBA Reference Application
// Copyright (c) 1997 by Borland International, All Rights Reserved
//
// Contains implementation for the EmptyStringNullListener Class.
//--------------------------------------------------------------------------------------------------

package borland.reference.creditapproval.client;

import borland.jbcl.dataset.*;
import borland.jbcl.util.Variant;
import java.util.*;

/**
* EmptyStringNullListener changes empty string column values to
* NULL. This allows RequiredFieldProcessing to work correctly.
*
* The Observable Class is extended so that column changes can be
* observed.
*/
public class EmptyStringNullListener extends Observable implements ColumnChangeListener{

  protected boolean emptyStringIsNull = true;

  public boolean isEmptyStringNull() {
    return emptyStringIsNull;
  }

  public void setEmptyStringNull( boolean newValue ) {
    emptyStringIsNull = newValue;
  }
  public EmptyStringNullListener() {
    super();
  }

  /**
  *  Change all Empty String values to NULL.
  */
  public void validate(DataSet attachedDataSet, Column changedColumn, Variant newValue) {
    if (newValue.toString().trim().compareTo("") == 0)
      newValue.setAssignedNull();
  }

  /**
  *  The data for this column was changed. Notify all observers that
  * registered an interest.
  */
  public void changed(DataSet attachedDataSet, Column changedColumn, Variant newValue) {
    setChanged();
    notifyObservers();
  }
}
