/*
 * Copyright (c) 1997-1998 Borland International, Inc. All Rights Reserved.
 * 
 * This SOURCE CODE FILE, which has been provided by Borland as part
 * of a Borland product for use ONLY by licensed users of the product,
 * includes CONFIDENTIAL and PROPRIETARY information of Borland.  
 *
 * USE OF THIS SOFTWARE IS GOVERNED BY THE TERMS AND CONDITIONS 
 * OF THE LICENSE STATEMENT AND LIMITED WARRANTY FURNISHED WITH
 * THE PRODUCT.
 *
 * IN PARTICULAR, YOU WILL INDEMNIFY AND HOLD BORLAND, ITS RELATED
 * COMPANIES AND ITS SUPPLIERS, HARMLESS FROM AND AGAINST ANY CLAIMS
 * OR LIABILITIES ARISING OUT OF THE USE, REPRODUCTION, OR DISTRIBUTION
 * OF YOUR PROGRAMS, INCLUDING ANY CLAIMS OR LIABILITIES ARISING OUT OF
 * OR RESULTING FROM THE USE, MODIFICATION, OR DISTRIBUTION OF PROGRAMS
 * OR FILES CREATED FROM, BASED ON, AND/OR DERIVED FROM THIS SOURCE
 * CODE FILE.
 */
package visibroker.samples.interceptor.timer;

import  com.visigenic.vbroker.interceptor.*;
import  com.visigenic.vbroker.IOP.*;

public class TimerBindInterceptor extends TimerInterceptor implements BindInterceptor
{
    public boolean bind(IORHolder ior, org.omg.CORBA.Object object, Closure closure)
    {
        closure.object = new TimerData();
        return false;
    }

    public boolean bind_failed(IORHolder ior, org.omg.CORBA.Object object, Closure closure)
    {
        print("bind", null, closure.object);
        return false;
    }

    public void bind_succeeded(IOR ior, org.omg.CORBA.Object object,Closure closure)
    {
        print("bind", null, closure.object);
    }

    public boolean rebind(IORHolder ior, org.omg.CORBA.Object object, Closure closure)
    {
        closure.object = new TimerData();
        return false;
    }

    public boolean rebind_failed(IORHolder ior, org.omg.CORBA.Object object, Closure closure)
    {
        print("rebind", null, closure.object);
        return false;
    }

    public void rebind_succeeded(IOR ior, org.omg.CORBA.Object object, Closure closure)
    {
        print("rebind", null, closure.object);
    }

    public void exception_occurred(IOR ior, org.omg.CORBA.Object object, org.omg.CORBA.Environment env, Closure closure)
    {
    }
}
